package com.zd.exam.mapper;

import com.zd.exam.domain.ElExamRepo;
import com.zd.exam.domain.vo.ExamConfig;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 考试题库(ElExamRepo)表数据库访问层
 *
 * @author liubo
 * @since 2021-08-31 09:23:50
 */
public interface ElExamRepoMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ElExamRepo queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<ElExamRepo> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param elExamRepo 实例对象
     * @return 对象列表
     */
    List<ElExamRepo> queryAll(ElExamRepo elExamRepo);

    /**
     * 新增数据
     *
     * @param elExamRepo 实例对象
     * @return 影响行数
     */
    int insert(ElExamRepo elExamRepo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExamRepo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ElExamRepo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExamRepo> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<ElExamRepo> entities);

    /**
     * 修改数据
     *
     * @param elExamRepo 实例对象
     * @return 影响行数
     */
    int update(ElExamRepo elExamRepo);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    int deleteByExamId(Long examId);

    ExamConfig selectSumScoreByExamId(Long examId);
}

